//------------------------------------------------------------------
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 PaleVioletRed
#property indicator_color3 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern double Samples1       = 41;
extern double Samples2       = 25;
extern double Suppression_dB =  0;
extern bool   AutoGainOn     = true;
extern int    PriceToUse     = PRICE_CLOSE;

//
//
//
//
//

double buffUp[];
double buffNe[];
double buffDn[];
double state[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffNe); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,state);
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double kalman1 = iCustom(NULL,0,"KalmanAGJW - new",Samples1,0,0,Suppression_dB,AutoGainOn,0,i);
      double kalman2 = iCustom(NULL,0,"KalmanAGJW - new",Samples2,0,0,Suppression_dB,AutoGainOn,0,i);
      double price   = iMA(NULL,0,1,0,MODE_SMA,PriceToUse,i);
         state[i] = 0;
         buffNe[i] = EMPTY_VALUE;
         buffUp[i] = EMPTY_VALUE;
         buffDn[i] = EMPTY_VALUE;
            if (price>kalman1 && price>kalman2) state[i] =  1;
            if (price<kalman1 && price<kalman2) state[i] = -1;
            if (state[i] ==  0) buffNe[i] = 1;
            if (state[i] ==  1) buffUp[i] = 1;
            if (state[i] == -1) buffDn[i] = 1;
     }
   return(0);
}

